Attribute VB_Name = "modACM"

' CDDA Writer Active X DLL
' Copyright (C) 2005  [rm_code]

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" _
Alias "RtlMoveMemory" ( _
    Destination As Any, Source As Any, ByVal Length As Long _
)

Public Declare Function acmStreamPrepareHeader Lib "msacm32" ( _
    ByVal has As Long, pash As ACMSTREAMHEADER, _
    ByVal fdwPrepare As Long _
) As Long

Public Declare Function acmStreamUnprepareHeader Lib "msacm32" ( _
    ByVal has As Long, pash As ACMSTREAMHEADER, ByVal fdwUnprepare As Long _
) As Long

Public Declare Function acmStreamOpen Lib "msacm32" ( _
    ByRef phas As Long, ByVal had As Long, pwfxSrc As Any, _
    pwfxDst As Any, ByVal pwfltr As Long, _
    ByVal dwCallback As Long, ByVal dwInstance As Long, _
    ByVal fdwOpen As Long _
) As Long

Public Declare Function acmStreamSize Lib "msacm32" ( _
    ByVal has As Long, ByVal cbInput As Long, _
    pdwOutputBytes As Long, ByVal fdwSize As Long _
) As Long

Public Declare Function acmStreamConvert Lib "msacm32" ( _
    ByVal has As Long, pash As ACMSTREAMHEADER, ByVal fdwConvert As Long _
) As Long

Public Declare Function acmMetrics Lib "msacm32" ( _
    ByVal hao As Long, ByVal uMetric As Integer, pMetric As Any _
) As Long

Public Declare Function acmDriverEnum Lib "msacm32" ( _
    ByVal fnCallback As Long, dwInstance As Long, ByVal fdwEnum As Long _
) As Long

Public Declare Function acmDriverDetails Lib "msacm32" _
Alias "acmDriverDetailsA" ( _
    ByVal hadid As Long, padd As TACMDRIVERDETAILS, _
    ByVal fdwDetails As Long _
) As Long

Public Declare Function acmDriverOpen Lib "msacm32" ( _
    ByRef phad As Long, ByVal hadid As Long, ByVal fdwOpen As Long _
) As Long

Public Declare Function acmDriverClose Lib "msacm32" ( _
    ByVal had As Long, ByVal fdwClose As Long _
) As Long

Public Declare Function acmFormatEnum Lib "msacm32" _
Alias "acmFormatEnumA" ( _
    ByVal had As Long, ByRef pafd As ACMFORMATDETAILS, _
    ByVal fnCallback As Long, ByRef dwInstance As Long, _
    ByVal fdwEnum As Long _
) As Long

Public Declare Function acmStreamClose Lib "msacm32" ( _
    ByVal has As Long, ByVal fdwClose As Long _
) As Long

Public Declare Function acmFormatTagDetails Lib "msacm32" _
Alias "acmFormatTagDetailsA" ( _
    ByVal had As Long, paftd As TACMFORMATTAGDETAILS, _
    ByVal fdwDetails As Long _
) As Long

Private Declare Function acmGetVersion Lib "msacm32" () As Long

Public Type TWAVEFORMATEX
    wFormatTag                  As Integer
    nChannels                   As Integer
    nSamplesPerSec              As Long
    nAvgBytesPerSec             As Long
    nBlockAlign                 As Integer
    wBitsPerSample              As Integer
    cbSize                      As Integer
    xBytes(11)                  As Byte
End Type

Public Type ACMFORMATDETAILS
    cbStruct                    As Long
    dwFormatIndex               As Long
    dwFormatTag                 As Long
    fdwSupport                  As Long
    pwfx                        As Long
    cbwfx                       As Long
    szFormat                    As String * 128
End Type

Public Type TACMDRIVERDETAILS
    cbStruct                    As Long
    fccType(3)                  As Byte
    fccComp(3)                  As Byte
    wMid                        As Integer
    wPid                        As Integer
    vdwACM                      As Long
    vdwDriver                   As Long
    fdwSupport                  As Long
    cFormatTags                 As Long
    cFilterTags                 As Long
    hIcon                       As Long
    szShortname                 As String * 32
    szLongName                  As String * 128
    szCopyright                 As String * 80
    szLicensing                 As String * 128
    szFeatures                  As String * 512
End Type

Public Type ACMSTREAMHEADER
    cbStruct                    As Long
    fdwStatus                   As Long
    dwUser                      As Long
    pbSrc                       As Long
    cbSrcLength                 As Long
    cbSrcLengthUsed             As Long
    dwSrcUser                   As Long
    pbDst                       As Long
    cbDstLength                 As Long
    cbDstLengthUsed             As Long
    dwDstUser                   As Long
    dwReservedDriver(9)         As Long
End Type

Public Type TACMFORMATTAGDETAILS
    cbStruct                    As Long
    dwFormatTagIndex            As Long
    dwFormatTag                 As Long
    cbFormatSize                As Long
    fdwSupport                  As Long
    cStandardFormats            As Long
    szFormatTag                 As String * 48
End Type

Public Type TWavHdr
    riff                        As String * 4
    len                         As Long
    WavFmt                      As String * 8
    HdrLen                      As Long
    format                      As Integer
    NumChannels                 As Integer
    SampleRate                  As Long
    BytesPerSec                 As Long
    BlockAlign                  As Integer
    BitsPerSample               As Integer
    Data                        As String * 4
    DataLen                     As Long
End Type

Public Const WAVE_FORMAT_UNKNOWN                   As Long = &H0
Public Const WAVE_FORMAT_PCM                       As Long = &H1
Public Const WAVE_FORMAT_MPEGLAYER3                As Long = &H55

Public Const ACMDRIVERDETAILS_SUPPORTF_CODEC       As Long = &H1
Public Const ACM_METRIC_MAX_SIZE_FORMAT            As Long = &H32
Public Const ACM_STREAMCONVERTF_BLOCKALIGN         As Long = &H4

Public Type FormatTag
    FormatTagIndex As Long
    FormatTag As Long
    szFormat As String
    wfx As TWAVEFORMATEX
End Type

Public Type acmDriver
    Handle As Long
    LongName As String
    ShortName As String
    FormatTagCount As Integer
    FormatTag() As FormatTag
End Type

Public Type drivers
    count As Integer
    drivers() As acmDriver
End Type
Public acmDrivers As drivers

Dim lngPower2(31)   As Long

Public Function ACMVersion() As String
    Dim major       As Integer
    Dim revision    As Integer
    Dim build       As Integer
    Dim ACMVer      As Long

    ACMVer = acmGetVersion

    major = RShift(((ACMVer And &HFFFF0000) / &H10000), 8)

    revision = ((ACMVer And &HFFFF0000) / &H10000) And &HFF

    build = ACMVer And &HFFFF&

    If build = 0 Then ACMVersion = " Retail"

    ACMVersion = major & "." & format$(revision, "00") & _
                 " Build " & build & ACMVersion
End Function

Public Sub ListCodecs()
    Dim mmr     As Long

    mmr = acmDriverEnum(AddressOf acmDriverEnumCallback, 0, 0)
End Sub

'callback for driver enumeration
Public Function acmDriverEnumCallback(ByVal haid As Long, _
                                      ByVal dwInstance As Long, _
                                      ByVal fdwSupport As Long) As Long

    Dim i           As Integer
    Dim driver      As Long
    Dim mmr         As Long


    'If the driver supports converting formats, ...
    If fdwSupport And ACMDRIVERDETAILS_SUPPORTF_CODEC Then

        'get its handle
        driver = 0
        mmr = acmDriverOpen(driver, haid, 0)

        'read details about it
        Dim details     As TACMDRIVERDETAILS
        details.cbStruct = Len(details)
        mmr = acmDriverDetails(haid, details, 0)

        Dim already_added As Boolean

        'go through all format tags
        For i = 1 To details.cFormatTags

            'get details to the current format tag
            Dim fmtTagDetails  As TACMFORMATTAGDETAILS
            fmtTagDetails.cbStruct = Len(fmtTagDetails)
            fmtTagDetails.dwFormatTagIndex = i
            mmr = acmFormatTagDetails(driver, fmtTagDetails, 0)

            If fmtTagDetails.dwFormatTag = WAVE_FORMAT_MPEGLAYER3 Then

                If Not already_added Then

                    ReDim Preserve acmDrivers.drivers(acmDrivers.count)

                    With acmDrivers.drivers(acmDrivers.count)
                        .Handle = haid
                        .LongName = details.szLongName
                        .ShortName = details.szShortname
                    End With

                    already_added = True

                End If

                Dim fmtDetails      As ACMFORMATDETAILS
                Dim wavformat       As TWAVEFORMATEX
        
                'prepare a enumeration of the supported formats
                wavformat.cbSize = Len(wavformat)
                wavformat.wFormatTag = WAVE_FORMAT_MPEGLAYER3
        
                'get the max. size of waveformatex
                Dim MaxSize         As Long
                acmMetrics driver, ACM_METRIC_MAX_SIZE_FORMAT, MaxSize
                If MaxSize < Len(wavformat) Then MaxSize = Len(wavformat)
        
                wavformat.cbSize = (MaxSize And &HFFFF&) - Len(wavformat)
                wavformat.wFormatTag = WAVE_FORMAT_UNKNOWN
        
                fmtDetails.cbStruct = Len(fmtDetails)
                fmtDetails.pwfx = VarPtr(wavformat)
                fmtDetails.cbwfx = MaxSize
                fmtDetails.dwFormatTag = WAVE_FORMAT_UNKNOWN
        
                'enumerate formats
                mmr = acmFormatEnum(driver, fmtDetails, _
                                    AddressOf acmFormatCallback, _
                                    0, 0)
            End If
        Next

        'close the driver handle
        mmr = acmDriverClose(driver, 0)

        If already_added Then
            acmDrivers.count = acmDrivers.count + 1
            already_added = False
        End If
    End If

    '1 for next driver,
    '0 for cancel
    acmDriverEnumCallback = 1
End Function

'callback for format enumeration
Public Function acmFormatCallback(ByVal hACMDriverID As Long, _
                                  ACMFmtDet As ACMFORMATDETAILS, _
                                  ByVal dwInstance As Long, _
                                  ByVal fdwSupport As Long) As Long

    Dim format As TWAVEFORMATEX

    '1 for next format,
    '0 for cancel
    acmFormatCallback = 1

    'copy data form WaveFormatEx pointer to wavformat
    CopyMemory format, ByVal ACMFmtDet.pwfx, Len(format)

    If format.wFormatTag = WAVE_FORMAT_MPEGLAYER3 Then
        If format.nSamplesPerSec = 44100 Then
            If format.nChannels = 2 Then
                'save format
                With acmDrivers.drivers(acmDrivers.count)
                    ReDim Preserve .FormatTag(.FormatTagCount) As FormatTag
            
                    With .FormatTag(.FormatTagCount)
                        .wfx = format
                        .FormatTag = ACMFmtDet.dwFormatTag
                        .FormatTagIndex = ACMFmtDet.dwFormatIndex
                        .szFormat = TrimNull(StrConv(ACMFmtDet.szFormat, _
                                                     vbUnicode))
                    End With

                End With
            
                With acmDrivers.drivers(acmDrivers.count)
                    .FormatTagCount = .FormatTagCount + 1
                End With
            End If
        End If
    End If
End Function

Public Function TrimNull(strVal As String) As String
    TrimNull = Left$(strVal, InStr(strVal, Chr$(0)) - 1)
End Function

Private Function RShift(ByVal lThis As Long, ByVal lBits As Long) As Long
   Static init As Boolean

   If Not init Then InitShifting: init = True

   If (lBits <= 0) Then
      RShift = lThis
   ElseIf (lBits > 63) Then
      Exit Function
   ElseIf (lBits > 31) Then
      RShift = 0
   Else
      If (lThis And lngPower2(31)) = lngPower2(31) Then
         RShift = (lThis And &H7FFFFFFF) \ lngPower2(lBits) Or lngPower2(31 - lBits)
      Else
         RShift = lThis \ lngPower2(lBits)
      End If
   End If
End Function

Private Sub InitShifting()
   lngPower2(0) = &H1&: lngPower2(1) = &H2&: lngPower2(2) = &H4&
   lngPower2(3) = &H8&: lngPower2(4) = &H10&: lngPower2(5) = &H20&
   lngPower2(6) = &H40&: lngPower2(7) = &H80&: lngPower2(8) = &H100&
   lngPower2(9) = &H200&: lngPower2(10) = &H400&: lngPower2(11) = &H800&
   lngPower2(12) = &H1000&: lngPower2(13) = &H2000&: lngPower2(14) = &H4000&
   lngPower2(15) = &H8000&: lngPower2(16) = &H10000: lngPower2(17) = &H20000
   lngPower2(18) = &H40000: lngPower2(19) = &H80000: lngPower2(20) = &H100000
   lngPower2(21) = &H200000: lngPower2(22) = &H400000: lngPower2(23) = &H800000
   lngPower2(24) = &H1000000: lngPower2(25) = &H2000000: lngPower2(26) = &H4000000
   lngPower2(27) = &H8000000: lngPower2(28) = &H10000000: lngPower2(29) = &H20000000
   lngPower2(30) = &H40000000: lngPower2(31) = &H80000000
End Sub
